remedial2/core/urls.py
from django.urls import path
from core import views

app_name = "core"

urlpatterns = [
    ## Estadio:
    path('list/estadio/', views.ListEstadio.as_view(), name="EstadioList"),
    path('create/estadio/', views.CreateEstadio.as_view(), name="EstadioCreate"),
    path('detail/estadio/<int:pk>/', views.DetailEstadio.as_view(), name="EstadioDetail"),
    path('update/estadio/<int:pk>/', views.UpdateEstadio.as_view(), name="EstadioUpdate"),
    path('delete/estadio/<int:pk>/', views.DeleteEstadio.as_view(), name="EstadioDelete"),

    ## Ciudad:
    path('list/ciudad/', views.ListCiudad.as_view(), name="CiudadList"),
    path('create/ciudad/', views.CreateCiudad.as_view(), name="CiudadCreate"),
    path('detail/ciudad/<int:pk>/', views.DetailCiudad.as_view(), name="CiudadDetail"),
    path('update/ciudad/<int:pk>/', views.UpdateCiudad.as_view(), name="CiudadUpdate"),
    path('delete/ciudad/<int:pk>/', views.DeleteCiudad.as_view(), name="CiudadDelete"),

    ## Equipo:
    path('list/equipo/', views.ListEquipo.as_view(), name="EquipoList"),
    path('create/equipo/', views.CreateEquipo.as_view(), name="EquipoCreate"),
    path('detail/equipo/<int:pk>/', views.DetailEquipo.as_view(), name="EquipoDetail"),
    path('update/equipo/<int:pk>/', views.UpdateEquipo.as_view(), name="EquipoUpdate"),
    path('delete/equipo/<int:pk>/', views.DeleteEquipo.as_view(), name="EquipoDelete"),
]

remedial2/remedial2/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('core/', include("core.urls")),
    path('', include("home.urls")),
]

remedial2/core/models.py
from django.db import models

# Create your models here.

from django.db.models.signals import pre_save
from django.dispatch import receiver

## -------------------------------- TEAM-NFL -------------------------------- ##

## CIUDADES:
class Ciudad(models.Model):
    NombreCiudad = models.CharField(max_length=80, blank=False, null=False)
    DescripcionCiudad = models.CharField(max_length=120, blank=False, null=False)

    def __str__(self):
        return self.NombreCiudad

## ESTADIOS:
class Estadio(models.Model):
    NombreEstadio = models.CharField(max_length=80, blank=False, null=False)
    DescripcionEstadio = models.CharField(max_length=120, blank=False, null=False)
    Ciudad = models.ForeignKey(Ciudad, on_delete=models.CASCADE)

    def __str__(self):
        return self.NombreEstadio

## EQUIPOS:
class Equipo(models.Model):
    NombreEquipo = models.CharField(max_length=80, blank=False, null=False)
    DescripcionEquipo = models.CharField(max_length=120, blank=False, null=False)
    Estadio = models.ForeignKey(Estadio, on_delete=models.CASCADE, blank=False, null=False)
    Ciudad = models.ForeignKey(Ciudad, on_delete=models.CASCADE, default=None)

    def __str__(self):
        return self.NombreEquipo

## Asignación automática de una ciudad.
@receiver(pre_save, sender=Equipo)
def AsignacionCiudad(sender, instance, **kwargs):
    if not getattr(instance, '_updating', False):
        instance._updating = True

        if instance.Estadio and instance.Estadio.Ciudad:
            instance.Ciudad = instance.Estadio.Ciudad
            instance.save()

        instance._updating = False

remedial2/core/forms.py
from django import forms
from .models import Ciudad, Estadio, Equipo

## ESTADIO: ----------------------------------------------------------------- ##

class EstadioForm(forms.ModelForm):
    Ciudad = forms.ModelChoiceField(queryset=Ciudad.objects.all(),
        empty_label="Selecciona una ciudad",
        widget=forms.Select(attrs={"class": "form-select-ancho"})
    )

    class Meta:
        model = Estadio
        fields = ['NombreEstadio', 'DescripcionEstadio', 'Ciudad']

        widgets = {
            "NombreEstadio": forms.TextInput(attrs={"type": "text", "class": "form-control", "placeholder": "Nombre del estadio"}),
            "DescripcionEstadio": forms.TextInput(attrs={"type": "text", "class": "form-control", "placeholder": "Descripción del estadio"}),
        }

class UpdateEstadioForm(forms.ModelForm):
    Ciudad = forms.ModelChoiceField(queryset=Ciudad.objects.all(),
        empty_label="Selecciona una ciudad",
        widget=forms.Select(attrs={"class": "form-select-ancho"})
    )

    class Meta:
        model = Estadio
        fields = ['NombreEstadio', 'DescripcionEstadio', 'Ciudad']

        widgets = {
            "NombreEstadio": forms.TextInput(attrs={"type": "text", "class": "form-control", "placeholder": "Nombre del estadio"}),
            "DescripcionEstadio": forms.TextInput(attrs={"type": "text", "class": "form-control", "placeholder": "Descripción del estadio"}),
        }

## CIUDAD: ------------------------------------------------------------------ ##

class CiudadForm(forms.ModelForm):
    class Meta:
        model = Ciudad
        fields = ['NombreCiudad', 'DescripcionCiudad']

        widgets = {
            "NombreCiudad" : forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Nombre",}),
            "DescripcionCiudad" : forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Descripción"})
        }

class UpdateCiudadForm(forms.ModelForm):
    class Meta:
        model = Ciudad
        fields = ['NombreCiudad', 'DescripcionCiudad']

        widgets = {
            "NombreCiudad" : forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Nombre",}),
            "DescripcionCiudad" : forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Descripción"})
        }

## EQUIPO: ------------------------------------------------------------------ ##

class EquipoForm(forms.ModelForm):
    Estadio = forms.ModelChoiceField(queryset=Estadio.objects.all(),
        empty_label="Selecciona un estadio",
        widget=forms.Select(attrs={"class": "form-select-ancho"})
    )

    class Meta:
        model = Equipo
        fields = ['NombreEquipo', 'DescripcionEquipo', 'Estadio']

        widgets = {
            'NombreEquipo': forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Nombre del equipo"}),
            'DescripcionEquipo': forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Descripción del equipo"}),
        }

class UpdateEquipoForm(forms.ModelForm):
    Estadio = forms.ModelChoiceField(queryset=Estadio.objects.all(),
        empty_label="Selecciona un estadio",
        widget=forms.Select(attrs={"class": "form-select-ancho"})
    )

    class Meta:
        model = Equipo
        fields = ['NombreEquipo', 'DescripcionEquipo', 'Estadio']

        widgets = {
            'NombreEquipo': forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Nombre del equipo"}),
            'DescripcionEquipo': forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Descripción del equipo"}),
        }

remedial2/core/views.py
from django.views import generic
from django.shortcuts import render
from django.urls import reverse_lazy

from .models import Ciudad, Estadio, Equipo
from .forms import CiudadForm, EstadioForm, EquipoForm, UpdateCiudadForm, UpdateEstadioForm, UpdateEquipoForm

# Create your views here.

## CREATE:
class CreateEstadio(generic.CreateView):
    model = Estadio
    form_class = EstadioForm
    template_name = "core/EstadioCreate.html"
    success_url = reverse_lazy('core:EstadioList')

## RETRIEVE (LIST - ESTADIO):
class ListEstadio(generic.View):
    template_name = "core/EstadioList.html"

    def get(self, request, *args, **kwargs):
        queryset = Estadio.objects.all()

        self.context = {
            "EstadioQ": queryset
        }
        return render(request, self.template_name, self.context)

## UPDATE:
class UpdateEstadio(generic.UpdateView):
    model = Estadio
    form_class = UpdateEstadioForm
    template_name = "core/EstadioUpdate.html"
    success_url = reverse_lazy("core:EstadioList")

## DELETE:
class DeleteEstadio(generic.DeleteView):
    model = Estadio
    template_name = "core/EstadioDelete.html"
    success_url = reverse_lazy("core:EstadioList")

## DETAIL:
class DetailEstadio(generic.DetailView):
    template_name = "core/EstadioDetail.html"
    model = Estadio

## CIUDAD: ------------------------------------------------------------------ ##

## CREATE:
class CreateCiudad(generic.CreateView):
    model = Ciudad
    form_class = CiudadForm
    template_name = "core/CiudadCreate.html"
    success_url = reverse_lazy('core:CiudadList')

## RETRIEVE (LIST - ESTADIO):
class ListCiudad(generic.View):
    template_name = "core/CiudadList.html"
    context = {}

    def get(self, request, *args, **kwargs):
        queryset = Ciudad.objects.all()

        self.context = {
            "CiudadQ" : queryset
        }
        return render(request, self.template_name, self.context)

## UPDATE:
class UpdateCiudad(generic.UpdateView):
    model = Ciudad
    form_class = UpdateCiudadForm
    template_name = "core/CiudadUpdate.html"
    success_url = reverse_lazy("core:CiudadList")

## DELETE:
class DeleteCiudad(generic.DeleteView):
    model = Ciudad
    template_name = "core/CiudadDelete.html"
    success_url = reverse_lazy("core:CiudadList")

## DETAIL:
class DetailCiudad(generic.DetailView):
    template_name = "core/CiudadDetail.html"
    model = Ciudad

## EQUIPO: ------------------------------------------------------------------ ##

class CreateEquipo(generic.CreateView):
    model = Equipo
    form_class = EquipoForm
    template_name = "core/EquipoCreate.html"
    success_url = reverse_lazy('core:EquipoList')

class ListEquipo(generic.View):
    template_name = "core/EquipoList.html"
    context = {}

    def get(self, request, *args, **kwargs):
        queryset = Equipo.objects.all()

        self.context = {
            "EquipoQ" : queryset
        }
        return render(request, self.template_name, self.context)

class UpdateEquipo(generic.UpdateView):
    model = Equipo
    form_class = UpdateEquipoForm
    template_name = "core/EquipoUpdate.html"
    success_url = reverse_lazy('core:EquipoList')

class DeleteEquipo(generic.DeleteView):
    model = Equipo
    template_name = "core/EquipoDelete.html"
    success_url = reverse_lazy('core:EquipoList')

## DETAIL:
class DetailEquipo(generic.DetailView):
    template_name = "core/EquipoDetail.html"
    model = Equipo

remedial2/templates/core/CiudadCreate.html
{% extends 'base/base.html'%}
{% block title %} REGISTRAR: Ciudad - VIEW {% endblock title %}

{% block content %}
<form action="" method="post" class="form">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-success">― REGISTRAR UNA NUEVA CIUDAD ―</h3>
    </div>

    <div class="form-outline mb-4">
        {{ form }}
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-success btn-dark w-25">Continuar</button>
        <a href="{% url 'core:CiudadList' %}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>

{% endblock content %}

remedial2/templates/core/CiudadDelete.html
{% extends "base/base.html" %}
{% block title %} ELIMINAR: Ciudad - VIEW {% endblock title %}

{% block content %}
<form action="" method="post">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-danger">¿Estás seguro de eliminar la ciudad: {{ object }}?</h3>
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-danger btn-dark w-25">Eliminar</button>
        <a href="{% url 'core:CiudadList'%}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>
{% endblock content %}

remedial2/templates/core/CiudadDetail.html
{% extends 'base/base.html' %}
{% block title %} INFO: Ciudad - VIEW {% endblock title %}

{% block content %}
<div class="text-center mb-5">
    <h2 class="text-success">― {{ object.NombreCiudad }} ―</h2>
</div>

<div class="text-center mb-5">
    <h4 class="text-secondary">DESCRIPCIÓN</h4>
    <p class="text-secondary">{{ object.DescripcionCiudad }}</p>
</div>

<div class="d-flex justify-content-between">
    <a href="{% url 'core:CiudadList' %}" class="btn btn-outline-success btn-dark w-100">Regresar</a>
</div>
{% endblock %}

remedial2/templates/core/CiudadList.html
{% extends 'base/base.html' %}
{% block title %} LISTADO: Ciudades - VIEW {% endblock title %}

{% block content %}
<div class="table-responsive">
    <a href="{% url 'core:CiudadCreate' %}" class="btn btn-outline-success form-control btn-info">REGISTRAR UNA NUEVA CIUDAD</a>

    <br>
    <br>

    <table class="table table-striped table-hover table-condensed table-dark text-center">

        <thead class="thead-dark">
            <tr>
                <th>ID</th>
                <th>Nombre</th>

                <th></th>
                <th>Acciones</th>
                <th></th>
            </tr>
        </thead>

        <tbody>
            {% for CD in CiudadQ %}
                <tr>
                <td>{{ CD.id }}</td>
                    <td>{{ CD.NombreCiudad }}</td>
                    <td><a href="{% url 'core:CiudadDetail' CD.id %}" class="btn btn-info btn-sm">Detalles</a></td>
                    <td><a href="{% url 'core:CiudadUpdate' CD.id %}" class="btn btn-warning btn-sm">Actualizar</a></td>
                    <td><a href="{% url 'core:CiudadDelete' CD.id %}" class="btn btn-danger btn-sm">Eliminar</a></td>
                </tr>
            {% endfor %}
        </tbody>

    </table>
</div>
{% endblock content %}

remedial2/templates/core/CiudadUpdate.html
{% extends 'base/base.html'%}
{% block title %} ACTUALIZAR: Ciudad - VIEW {% endblock title %}

{% block content %}
<form action="" method="post" class="form">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-success">― ACTUALIZAR UNA CIUDAD EXISTENTE―</h3>
    </div>

    <div class="form-outline mb-4">
        {{ form }}
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-success btn-dark w-25">Continuar</button>
        <a href="{% url 'core:CiudadList' %}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>

{% endblock content %}

remedial2/templates/core/EquipoCreate.html
{% extends 'base/base.html'%}
{% block title %} REGISTRAR: Equipo - VIEW {% endblock title %}

{% block content %}
<form action="" method="post" class="form">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-success">― REGISTRAR UN NUEVO EQUIPO ―</h3>
    </div>

    <div class="form-outline mb-4">
        {{ form }}
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-success btn-dark w-25">Continuar</button>
        <a href="{% url 'core:EquipoList' %}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>

{% endblock content %}

remedial2/templates/core/EquipoDelete.html
{% extends "base/base.html" %}
{% block title %} ELIMINAR: Equipo - VIEW {% endblock title %}

{% block content %}
<form action="" method="post">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-danger">¿Estás seguro de eliminar el equipo: {{ object }}?</h3>
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-danger btn-dark w-25">Eliminar</button>
        <a href="{% url 'core:CiudadList'%}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>
{% endblock content %}

remedial2/templates/core/EquipoDetail.html
{% extends 'base/base.html' %}
{% block title %} INFO: Equipo - VIEW {% endblock title %}

{% block content %}
<div class="text-center mb-5">
    <h2 class="text-success">― {{ object.NombreEquipo }} ―</h2>
</div>

<div class="text-center mb-3">
    <h4 class="text-secondary">DESCRIPCIÓN</h4>
    <p class="text-secondary">{{ object.DescripcionEquipo }}</p>
</div>

<div class="text-center mb-5">
    <h4 class="text-secondary">ESTADIO</h4>
    <p class="text-secondary">Este equipo ha jugado en el estadio {{ object.Estadio }}
    <br>El estadio {{ object.Estadio }}, está ubicado en la ciudad de {{ object.Ciudad }}</p>
</div>

<div class="d-flex justify-content-between">
    <a href="{% url 'core:EquipoList' %}" class="btn btn-outline-success btn-dark w-100">Regresar</a>
</div>
{% endblock %}

remedial2/templates/core/EquipoList.html
{% extends 'base/base.html' %}
{% block title %} LISTADO: Equipos - VIEW {% endblock title %}

{% block content %}
<div class="table-responsive">
    <a href="{% url 'core:EquipoCreate' %}" class="btn btn-outline-success form-control btn-info">REGISTRAR UN NUEVO EQUIPO</a>

    <br>
    <br>

    <table class="table table-striped table-hover table-condensed table-dark text-center">

        <thead class="thead-dark">
            <tr>
                <th>ID</th>
                <th>Nombre</th>

                <th></th>
                <th>Acciones</th>
                <th></th>
            </tr>
        </thead>

        <tbody>
            {% for EQ in EquipoQ %}
                <tr>
                    <td>{{ EQ.id }}</td>
                    <td>{{ EQ.NombreEquipo }}</td>
                    <td><a href="{% url 'core:EquipoDetail' EQ.id %}" class="btn btn-info btn-sm">Detalles</a></td>
                    <td><a href="{% url 'core:EquipoUpdate' EQ.id %}" class="btn btn-warning btn-sm">Actualizar</a></td>
                    <td><a href="{% url 'core:EquipoDelete' EQ.id %}" class="btn btn-danger btn-sm">Eliminar</a></td>
                </tr>
            {% endfor %}
        </tbody>

    </table>
</div>
{% endblock content %}

remedial2/templates/core/EstadioCreate.html
{% extends 'base/base.html'%}
{% block title %} REGISTRAR: Estadio - VIEW {% endblock title %}

{% block content %}
<form action="" method="post" class="form">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-success">― REGISTRAR UN NUEVO ESTADIO ―</h3>
    </div>

    <div class="form-outline mb-4">
        {{ form }}
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-success btn-dark w-25">Continuar</button>
        <a href="{% url 'core:EstadioList' %}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>

{% endblock content %}

remedial2/templates/core/EstadioDelete.html
{% extends "base/base.html" %}
{% block title %} ELIMINAR: Estadio - VIEW {% endblock title %}

{% block content %}
<form action="" method="post">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-danger">¿Estás seguro de eliminar el estadio: {{ object }}?</h3>
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-danger btn-dark w-25">Eliminar</button>
        <a href="{% url 'core:CiudadList'%}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>
{% endblock content %}

remedial2/templates/core/EstadioDetail.html
{% extends 'base/base.html' %}
{% block title %} INFO: Estadio - VIEW {% endblock title %}

{% block content %}
<div class="text-center mb-5">
    <h2 class="text-success">― {{ object.NombreEstadio }} ―</h2>
</div>

<div class="text-center mb-3">
    <h4 class="text-secondary">DESCRIPCIÓN</h4>
    <p class="text-secondary">{{ object.DescripcionEstadio }}</p>
</div>

<div class="text-center mb-5">
    <h4 class="text-secondary">CIUDAD</h4>
    <p class="text-secondary">Este estadio está ubicado en la ciudad de {{ object.Ciudad }}</p>
</div>

<div class="d-flex justify-content-between">
    <a href="{% url 'core:EstadioList' %}" class="btn btn-outline-success btn-dark w-100">Regresar</a>
</div>
{% endblock %}

remedial2/templates/core/EstadioList.html
{% extends 'base/base.html' %}
{% block title %} LISTADO: Estadios - VIEW {% endblock title %}

{% block content %}
<div class="table-responsive">
    <a href="{% url 'core:EstadioCreate' %}" class="btn btn-outline-success form-control btn-info">REGISTRAR UN NUEVO ESTADIO</a>

    <br>
    <br>

    <table class="table table-striped table-hover table-condensed table-dark text-center">

        <thead class="thead-dark">
            <tr>
                <th>ID</th>
                <th>Nombre</th>

                <th></th>
                <th>Acciones</th>
                <th></th>
            </tr>
        </thead>

        <tbody>
            {% for ET in EstadioQ %}
                <tr>
                <td>{{ ET.id }}</td>
                    <td>{{ ET.NombreEstadio }}</td>
                    <td><a href="{% url 'core:EstadioDetail' ET.id %}" class="btn btn-info btn-sm">Detalles</a></td>
                    <td><a href="{% url 'core:EstadioUpdate' ET.id %}" class="btn btn-warning btn-sm">Actualizar</a></td>
                    <td><a href="{% url 'core:EstadioDelete' ET.id %}" class="btn btn-danger btn-sm">Eliminar</a></td>
                </tr>
            {% endfor %}
        </tbody>

    </table>
</div>
{% endblock content %}

remedial2/templates/core/EstadioUpdate.html
{% extends 'base/base.html'%}
{% block title %} ACTUALIZAR: Estadio - VIEW {% endblock title %}

{% block content %}
<form action="" method="post" class="form">
    {% csrf_token %}

    <div class="row mb-4">
        <h3 class="text-center text-success">― ACTUALIZAR UN ESTADIO EXISTENTE ―</h3>
    </div>

    <div class="form-outline mb-4">
        {{ form }}
    </div>

    <div class="d-flex justify-content-between mt-2">
        <button type="submit" class="btn btn-outline-success btn-dark w-25">Continuar</button>
        <a href="{% url 'core:EstadioList' %}" class="btn btn-outline-warning btn-dark w-25">Cancelar</a>
    </div>

</form>

{% endblock content %}